# define driver name, version and release
%define		drvname	nvidia173
%define		drvver	173.14.38
%define		drvrel	1.mga3.nonfree

# define core kernel version we build against
%define 	kernver		3.10.28
%define		kernrel		1.mga3

# where to build
%define		topdir		${RPM_BUILD_DIR}/%{name}-%{_arch}

# source package
Name:		kmod-%{drvname}
Version:	%{drvver}
Release:	%mkrel 27
Summary:	Prebuilt %{drvname} modules for kernel-%{kernver}-%{kernrel}
License:	Freeware
URL:		http://www.nvidia.com/object/unix.html
Group:		System/Kernel and hardware
ExclusiveArch:	%{ix86} x86_64

BuildRequires:	dkms-%{drvname} = %{drvver}-%{drvrel}
%ifarch %{ix86}
BuildRequires:	kernel-desktop586-devel-%{kernver}-%{kernrel}
%endif
BuildRequires:	kernel-desktop-devel-%{kernver}-%{kernrel}
BuildRequires:	kernel-server-devel-%{kernver}-%{kernrel}

%description
This package creates prebuilt %{drvname} kernel modules for core kernel.


# obsoletes prebuilt -netbook-latest modules with matching -desktop-latest
%define latest_obsoletes_desktop %{drvname}-kernel-netbook-latest < 173.14.36-4
%define latest_provides_desktop  %{drvname}-kernel-netbook-latest = %{drvver}-%{release}

##### mkflavour() ala core kernel #####
%define mkflavour()								\
%package -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}			\
Summary:	%{drvname} driver for kernel-%{1}-%{kernver}-%{kernrel}		\
License:	Commercial							\
URL:		http://www.nvidia.com/object/unix.html				\
Group:		System/Kernel and hardware					\
Requires(post): dkms-minimal							\
Requires(preun): dkms-minimal							\
Requires:	kernel-%{1}-%{kernver}-%{kernrel}				\
Requires(post):	kernel-%{1}-%{kernver}-%{kernrel}				\
Requires(preun): kernel-%{1}-%{kernver}-%{kernrel}				\
Suggests:	%{drvname}-kernel-%{1}-latest					\
%ifarch %{ix86}									\
Conflicts:	arch(x86_64)							\
%endif										\
										\
%description -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}			\
Prebuilt dkms binary kernel modules for the %{drvname} driver version %{drvver} \
built for kernel-%{1}-%{kernver}-%{kernrel}.					\
										\
%files -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%dir /var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-%{1}-%{kernrel} \
/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-%{1}-%{kernrel}/* \
										\
%post -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%{_sbindir}/dkms install --binary -m %{drvname} -v %{drvver}-%{drvrel} -k %{kernver}-%{1}-%{kernrel} --rpm_safe_upgrade \
%{_sbindir}/dkms status -m %{drvname} -v %{drvver}-%{drvrel}			\
										\
%preun -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%{_sbindir}/dkms uninstall --binary -m %{drvname} -v %{drvver}-%{drvrel} -k %{kernver}-%{1}-%{kernrel} --rpm_safe_upgrade \
										\
										\
%package -n %{drvname}-kernel-%{1}-latest					\
Summary:	Virtual rpm for latest %{drvname}-kernel-%{1} driver		\
License:	Commercial							\
URL:		http://www.nvidia.com/object/unix.html				\
Group:		System/Kernel and hardware					\
Requires:	%{drvname}-kernel-%{kernver}-%{1}-%{kernrel} = %{version}-%{release} \
%{expand:%%{?latest_obsoletes_%{1}:Obsoletes: %{latest_obsoletes_%{1}}}}	\
%{expand:%%{?latest_provides_%{1}:Provides: %{latest_provides_%{1}}}}		\
%ifarch %{ix86}									\
Conflicts:	arch(x86_64)							\
%endif										\
										\
%description -n %{drvname}-kernel-%{1}-latest					\
This package is a virtual rpm that aims to make sure you always have the	\
latest prebuilt %{drvname} driver for kernel-%{1}.				\
										\
%files -n %{drvname}-kernel-%{1}-latest

%ifarch %{ix86}
%mkflavour desktop586
%endif

%mkflavour desktop
%mkflavour server


%prep
rm -rf %{topdir}

%build
%{_sbindir}/dkms add -m %{drvname} -v %{drvver}-%{drvrel} --dkmstree %{topdir}/var/lib/dkms-binary
%ifarch %{ix86}
%{_sbindir}/dkms build --no-prepare-kernel --no-clean-kernel -m %{drvname} -v %{drvver}-%{drvrel} \
	    -k %{kernver}-desktop586-%{kernrel} --kernelsourcedir /usr/src/linux-%{kernver}-desktop586-%{kernrel} \
	    --dkmstree %{topdir}/var/lib/dkms-binary
%endif
for flavour in desktop server; do
    %{_sbindir}/dkms build --no-prepare-kernel --no-clean-kernel -m %{drvname} -v %{drvver}-%{drvrel} \
		-k %{kernver}-$flavour-%{kernrel} --kernelsourcedir /usr/src/linux-%{kernver}-$flavour-%{kernrel} \
		--dkmstree %{topdir}/var/lib/dkms-binary
done

%install
mkdir -p %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}
cp -a %{topdir}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-*-%{kernrel} \
      %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/
for dir in %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-*-%{kernrel}; do
    cp -a /usr/src/%{drvname}-%{drvver}-%{drvrel}/dkms.conf $dir/
    xz -6e $dir/*/module/%{drvname}.ko ||:
done


%changelog
* Sun Feb 02 2014 tmb <tmb> 173.14.38-27.mga3
+ Revision: 568622
- rebuild for kernel-3.10.28-1.mga3
- rebuild for kernel-3.10.27-1.mga3
- rebuild for kernel-3.10.25-1.mga3
- rebuild for kernel-3.10.24-2.mga3
- rebuild for kernel-3.10.24-1.mga3
- rebuild for kernel-3.10.22-1.mga3
- rebuild for kernel-3.10.19-1.mga3
- rebuild for kernel-3.10.18-1.mga3
- rebuild for kernel-3.10.16-1.mga3
- rebuild for kernel-3.10.15-1.mga3 and nvidia173-173.14.38-1.mga3
- rebuild for kernel-3.10.12-1.mga3
- rebuild for kernel-3.8.13.4-1.mga3
- rebuild for kernel-3.8.13.3-2.mga3
- rebuild for kernel-3.8.13.3-1.mga3

* Tue May 14 2013 tmb <tmb> 173.14.37-13.mga3.nonfree
+ Revision: 413198
- rebuild for kernel-3.8.13-1.mga3

* Fri May 10 2013 tmb <tmb> 173.14.37-12.mga3.nonfree
+ Revision: 412838
- rebuild for kernel-3.8.12-2.mga3

* Wed May 08 2013 tmb <tmb> 173.14.37-11.mga3.nonfree
+ Revision: 412680
- rebuild for kernel-3.8.12-1.mga3

* Wed May 01 2013 tmb <tmb> 173.14.37-10.mga3.nonfree
+ Revision: 411831
- rebuild for kernel-3.8.11-1.mga3

* Sat Apr 27 2013 tmb <tmb> 173.14.37-9.mga3.nonfree
+ Revision: 411364
- rebuild for kernel-3.8.10-1.mga3

* Mon Apr 22 2013 tmb <tmb> 173.14.37-8.mga3.nonfree
+ Revision: 410895
- rebuild for kernel-3.8.8-3.mga3

* Sat Apr 20 2013 tmb <tmb> 173.14.37-7.mga3.nonfree
+ Revision: 410594
- rebuild for kernel-3.8.8-2.mga3

* Wed Apr 17 2013 tmb <tmb> 173.14.37-6.mga3.nonfree
+ Revision: 410299
- rebuild for kernel-3.8.8-1.mga3

* Sat Apr 13 2013 tmb <tmb> 173.14.37-5.mga3.nonfree
+ Revision: 409936
- rebuild for kernel-3.8.7-1.mga3

* Tue Apr 09 2013 tmb <tmb> 173.14.37-4.mga3.nonfree
+ Revision: 409296
- rebuild for kernel-3.8.6-2.mga3

* Sun Apr 07 2013 tmb <tmb> 173.14.37-3.mga3.nonfree
+ Revision: 408769
- rebuild for kernel-3.8.6-1.mga3

* Sat Mar 30 2013 tmb <tmb> 173.14.37-2.mga3.nonfree
+ Revision: 406636
- rebuild for kernel-3.8.5-1.mga3

* Sat Mar 23 2013 tmb <tmb> 173.14.37-1.mga3.nonfree
+ Revision: 404645
- rebuild for nvidia173-173.14.37-1.mga3

* Mon Mar 18 2013 tmb <tmb> 173.14.36-20.mga3.nonfree
+ Revision: 403968
- rebuild for kernel-3.8.3-2.mga3

* Fri Mar 15 2013 tmb <tmb> 173.14.36-19.mga3.nonfree
+ Revision: 403329
- rebuild for kernel-3.8.3-1.mga3

* Sat Mar 02 2013 tmb <tmb> 173.14.36-18.mga3.nonfree
+ Revision: 401097
- rebuild for kernel-3.8.1-1.mga3

* Thu Feb 28 2013 tmb <tmb> 173.14.36-17.mga3.nonfree
+ Revision: 400596
- rebuild for kernel-3.8.0-3.mga3

* Fri Feb 22 2013 tmb <tmb> 173.14.36-16.mga3.nonfree
+ Revision: 399993
- rebuild for kernel-3.8.0-2.mga3

* Tue Feb 19 2013 tmb <tmb> 173.14.36-15.mga3.nonfree
+ Revision: 399325
- rebuild for kernel-3.8.0-1.mga3

* Sat Feb 09 2013 tmb <tmb> 173.14.36-14.mga3.nonfree
+ Revision: 397385
- rebuild for kernel-3.8.0-0.rc7.1.mga3

* Wed Feb 06 2013 tmb <tmb> 173.14.36-13.mga3.nonfree
+ Revision: 394965
- rebuild for kernel-3.8.0-0.rc6.1.mga3

* Sun Jan 27 2013 tmb <tmb> 173.14.36-12.mga3.nonfree
+ Revision: 392638
- rebuild for kernel-3.8.0-0.rc5.1.mga3

* Fri Jan 18 2013 tmb <tmb> 173.14.36-11.mga3.nonfree
+ Revision: 389514
- rebuild for kernel-3.8.0-0.rc4.1.mga3

* Wed Jan 16 2013 tmb <tmb> 173.14.36-10.mga3.nonfree
+ Revision: 388878
- rebuild for kernel-3.8.0-0.rc3.2.mga3

* Tue Jan 15 2013 fwang <fwang> 173.14.36-9.mga3.nonfree
+ Revision: 388333
- rebuild for new driver

* Thu Jan 10 2013 tmb <tmb> 173.14.36-8.mga3.nonfree
+ Revision: 344836
- rebuild with fixed nvidia173-173.14.36-4.mga3
- rebuild for kernel-3.8.0-0.rc3.1.mga3

* Tue Dec 18 2012 tmb <tmb> 173.14.36-6.mga3.nonfree
+ Revision: 332490
- rebuild for kernel-3.7.1-1.mga3

* Tue Dec 11 2012 tmb <tmb> 173.14.36-5.mga3.nonfree
+ Revision: 329584
- rebuild for kernel-3.7.0-1.mga3

* Fri Dec 07 2012 tmb <tmb> 173.14.36-4.mga3.nonfree
+ Revision: 327720
- rebuild for fixed nvidia173-173.14.36-3.mga3
- fix obsolete version
- kernel-netbook is gone, so have -netbook-latest packages update to
  matching -desktop-latest
- rebuild for kernel-3.7.0-0.rc8.1.mga3
- ingore already compressed modules

* Fri Nov 02 2012 tmb <tmb> 173.14.36-3.mga3.nonfree
+ Revision: 312661
- rebuild for nvidia173-173.14.36-2.mga3

* Thu Nov 01 2012 tmb <tmb> 173.14.36-2.mga3.nonfree
+ Revision: 311854
- rebuild for kernel-3.6.5-1.mga3

* Wed Oct 31 2012 tmb <tmb> 173.14.36-1.mga3.nonfree
+ Revision: 311769
- rebuild for nvidia173-173.14.36-1.mga3
- rebuild for kernel 3.3-rc7
- rebuild for kernel-3.3.0-0.rc6.1.mga2

* Sat Mar 03 2012 tmb <tmb> 173.14.31-16.mga2.nonfree
+ Revision: 217298
- rebuild for kernel-3.2.9-2.mga2

* Thu Mar 01 2012 tmb <tmb> 173.14.31-15.mga2.nonfree
+ Revision: 216405
- rebuild for kernel-3.2.9-1.mga2

* Sat Feb 25 2012 tmb <tmb> 173.14.31-13.mga2.nonfree
+ Revision: 214774
- rebuild for kernel-3.2.7-1.mga2

* Thu Feb 16 2012 tmb <tmb> 173.14.31-12.mga2.nonfree
+ Revision: 209780
- rebuild for kernel-3.2.6-3.mga2
- compress modules with xz

* Tue Feb 14 2012 tmb <tmb> 173.14.31-11.mga2.nonfree
+ Revision: 208939
- rebuild for kernel-3.2.6-2.mga2

* Sun Feb 12 2012 tmb <tmb> 173.14.31-10.mga2.nonfree
+ Revision: 208065
- rebuild for kernel-3.2.6-0.rc1.1.mga2

* Mon Feb 06 2012 tmb <tmb> 173.14.31-9.mga2.nonfree
+ Revision: 205608
- rebuild for kernel-3.2.5-1.mga2

* Thu Jan 26 2012 tmb <tmb> 173.14.31-8.mga2.nonfree
+ Revision: 201948
- rebuild for kernel-3.2.2-1.mga2

* Fri Jan 20 2012 tmb <tmb> 173.14.31-7.mga2.nonfree
+ Revision: 198866
- build with kernel-3.2.1-2.mga2

* Sun Jan 15 2012 tmb <tmb> 173.14.31-6.mga2.nonfree
+ Revision: 196457
- kernel-xen-pvops does not exist anymore
- build against kernel-3.2.1-1.mga2

* Sun Jan 15 2012 tmb <tmb> 173.14.31-5.mga2.nonfree
+ Revision: 196312
- fix package name to match kernel uname -r

* Thu Jan 05 2012 tmb <tmb> 173.14.31-4.mga2.nonfree
+ Revision: 191561
- build with kernel-3.2.0-1.mga2

* Thu Dec 29 2011 tmb <tmb> 173.14.31-3.mga2.nonfree
+ Revision: 188529
- build with kernel-3.2.0-0.rc7.2.mga2
- fix url

* Mon Dec 26 2011 tmb <tmb> 173.14.31-2.mga2.nonfree
+ Revision: 187918
- build for kernel-3.2.0-0.rc7.1.mga2

* Mon Dec 26 2011 tmb <tmb> 173.14.31-1.mga2.nonfree
+ Revision: 187882
- imported package kmod-nvidia173

